=== debian/changelog ===
ros-galactic-rslidar-sdk (1.3.2-1focal) focal; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- robosense <zdxiao@robosense.cn>  Wed, 09 Mar 2022 11:52:01 -0000
